/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

/* AsciiLut.h */

#ifndef __INC_ASCIILUT__
#define __INC_ASCIILUT__

#include <windows.h>

#ifdef __cplusplus
extern "C" { // Assume C declarations for C++
#endif       // __cplusplus

//-----------------------------------------------------------------------------------
void Init6BitLut   (char Lut[64]);
void Invers6BitLut (char Lut[64], char InvLut[256]);
void Mix6BitLut    (long *rnd, int nPass, char Lut[64]);

int  Convert8to6Bit(int nBytes, char *aBytes, char *aCodes);
int  Convert6to8Bit(int nCodes, char *aCodes, char *aBytes);

void Convert6toASCII(char Lut[64], int nCodes, char *aCode, char *szOut);
int  ConvertASCIIto6(char InvLut[256], int nAscii, char *szAscii, char *aCodeOut);

char * GetStatic6BitLut(void);
char * GetStaticInvLut (void);


char * LoadText(char *szFileName, long *pSize);
BOOL   SaveText(char *szFileName, long nText, char *pText);

//-----------------------------------------------------------------------------------
#ifdef __cplusplus
}       // End of extern "C" {
#endif  // __cplusplus

//-----------------------------------------------------------------------------------

#endif  //ifndef __INC_ASCIILUT__
