/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgAbort.h: Abort Dialog Tools.
#ifndef __INC_DLGABORT__
#define __INC_DLGABORT__

#ifdef __cplusplus
extern "C" { // Assume C declarations for C++
#endif       // __cplusplus 

//-----------------------------------------------------------------------------------
// Resource-Identifier

#define IDD_ABORTDLG   98
#define IDST_ABORTINFO 99
#define IDB_ABORT      100

//-----------------------------------------------------------------------------------

typedef struct {
  long lData[8]; // Parameter
} ABORT_PROC_DATA;


typedef long (__cdecl * ABORT_PROC)(long lParam1, long lParam2, ABORT_PROC_DATA *pfData);

typedef struct {
  
  long        lParam1, lParam2;
  ABORT_PROC  pfAbortProc;

} ABORT_PROC_INFO;

//-----------------------------------------------------------------------------------

typedef struct {
  LPSTR   AbortTitel;       // Titel des Abort-Windows
  LPSTR   AbortText;        // Text des Abort-Boxes
  BOOL    bUserAbort;       // Flag fr Abort
  BOOL    bDisable;         // Flag fr Vaterfenster disablen
  FARPROC lpAbortProc;      // Proc-Instanz
  HWND    hPWnd;            // Handle fr Vaterfenster
  HWND    hAbortDlg;        // Handle fr Dialogbox
} USERABORTREC;
typedef USERABORTREC far *USERABORT;

/****************************************************************************/
HWND WINAPI AbortInstall(HWND hWnd, BOOL Enable, LPSTR  Titel, LPSTR  Text);

// Installiert eine Abort-Dialog-Box :
// HWND hWnd            : bergeordnetes (Vater-)Fenster
// LPSTR  Titel         : Titel der Abort-Dialog-Box
// LPSTR  Text          : Textinhalt der Abort-Dialog-Box

/****************************************************************************/
BOOL WINAPI AbortRemove(HWND hWnd);

// Entfernt zuvor installierte Abort-Dialog-Box

/****************************************************************************/
BOOL WINAPI Abort(HWND hWnd);

// Hier kann erfragt werden, ob Abort gedrckt wurde :
// Rckgabewert : TRUE  = Abort-Taste gedrckt
//                FALSE = keine Abort-Taste gedrckt

/****************************************************************************/
BOOL CALLBACK AbortDlg(HWND, unsigned, WORD, LONG);
void WINAPI AbortSetText(HWND hWnd, LPSTR Text);
void WINAPI AbortSetTitle(HWND hWnd, LPSTR Title);
void WINAPI AbortDlgSetSize(HWND hWnd, int cx, int cy);
void WINAPI AbortAutoPlace(HWND hDlg);

//-----------------------------------------------------------------------------------


#ifdef __cplusplus
}       // End of extern "C" {
#endif  // __cplusplus


//-----------------------------------------------------------------------------------


#endif // #ifndef __INC_DLGABORT__
