/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgEnterKey.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "Resource.h"
#include "DlgEnterKey.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgEnterKey 


CDlgEnterKey::CDlgEnterKey(CString sTitle, int minPassword, int maxPassword, LPTSTR pPassword, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEnterKey::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgEnterKey)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
  m_sTitle = sTitle;
  minPwd = minPassword;
  maxPwd = maxPassword;
  pPwd   = pPassword;
}


void CDlgEnterKey::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgEnterKey)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgEnterKey, CDialog)
	//{{AFX_MSG_MAP(CDlgEnterKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgEnterKey 

void CDlgEnterKey::OnOK() 
{
  BOOL  bBreak = FALSE;
  int   n1, n2;
  TCHAR szPwd1[MAX_PWD_SIZE+1];
  TCHAR szPwd2[MAX_PWD_SIZE+1];
 
  n1 = GetDlgItemText(IDC_EDITKEY1, szPwd1, MAX_PWD_SIZE);
  n2 = GetDlgItemText(IDC_EDITKEY2, szPwd2, MAX_PWD_SIZE);
  if (n1 != n2 || _tcsicmp(szPwd1, szPwd2) != 0) 
  {
    bBreak = TRUE;
    CString sMsg((LPCSTR)IDS_PWDNOTEQ);
    CString sTitle((LPCSTR)IDS_PWDERROR);
    MessageBeep(0);
    MessageBox(sMsg, sTitle, MB_ICONERROR | MB_OK);
  }
  else if (n1 < minPwd)
  {
    bBreak = TRUE;
    CString sMsg((LPCSTR)IDS_PWDTOSHORT);
    CString sTitle((LPCSTR)IDS_PWDERROR);
    MessageBeep(0);
    _stprintf(szPwd1, sMsg, minPwd);
    MessageBox(szPwd1, sTitle, MB_ICONERROR | MB_OK);
  }

  SetDlgItemText(IDC_EDITKEY1, TEXT(""));
  SetDlgItemText(IDC_EDITKEY2, TEXT(""));
  GetDlgItem(IDC_EDITKEY1)->SetFocus();
  if (bBreak) return; // Fehlerhaftes Abbrechen

  //
  // berprfung bestanden: Passwort bernehmen
  //
  _tcscpy(pPwd, szPwd1);

  // Temporre Passwrter berschreiben und vernichten
  for (int i=0; i < MAX_PWD_SIZE; i++)
    szPwd1[i] = szPwd2[i] = TCHAR('*');

  szPwd1[MAX_PWD_SIZE] = szPwd2[MAX_PWD_SIZE] = '\0';
  SetDlgItemText(IDC_EDITKEY1, szPwd1);
  SetDlgItemText(IDC_EDITKEY2, szPwd2);

	CDialog::OnOK();
}

BOOL CDlgEnterKey::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (!m_sTitle.IsEmpty())
    SetWindowText(m_sTitle);

  ((CEdit *)GetDlgItem(IDC_EDITKEY1))->SetLimitText(maxPwd);
  ((CEdit *)GetDlgItem(IDC_EDITKEY2))->SetLimitText(maxPwd);

  return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}
