/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/
// DlgKeyWiz1.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "DlgKeyWiz1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseite CDlgKeyWiz1 

CDlgKeyWiz1::CDlgKeyWiz1(CDlgKeyWizard *pPropSh) : CPropertyPage(CDlgKeyWiz1::IDD)
{
	//{{AFX_DATA_INIT(CDlgKeyWiz1)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

  _pPropSh = pPropSh;
}

CDlgKeyWiz1::~CDlgKeyWiz1()
{
}

void CDlgKeyWiz1::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKeyWiz1)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgKeyWiz1, CPropertyPage)
	//{{AFX_MSG_MAP(CDlgKeyWiz1)
	ON_BN_CLICKED(IDC_WIZ1BROWSE, OnWiz1Browse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgKeyWiz1 

BOOL CDlgKeyWiz1::OnSetActive() 
{
  if (_pPropSh->m_szKeyFile[0] != '\0')
      _pPropSh->SetWizardButtons( PSWIZB_NEXT );
  else _pPropSh->SetWizardButtons(0);
	
	return CPropertyPage::OnSetActive();
}

void CDlgKeyWiz1::OnWiz1Browse() 
{
  CFileDialog FileDlg(FALSE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szKeyFileMask, //lpszDefExt        The default filename extension
                      "",      //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_LONGNAMES, 
                      szKeyFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 1024;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_SELKEYFILE);
    strcpy(FileDlg.m_ofn.lpstrFile, AppSettings.KeyFileHistory[0].szKeyFile);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      CString sFile;

      sFile = FileDlg.GetPathName();
      SetDlgItemText(IDC_WIZKEYNAME, sFile);
      strcpy(_pPropSh->m_szKeyFile, sFile);
      _pPropSh->SetWizardButtons( PSWIZB_NEXT );
    }
    
    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);
	
}
