/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgKeyWiz2.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "Resource.h"
#include "DlgKeyWiz2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseite CDlgKeyWiz2 

CDlgKeyWiz2::CDlgKeyWiz2(CDlgKeyWizard *pPropSh) : CPropertyPage(CDlgKeyWiz2::IDD)
{
	//{{AFX_DATA_INIT(CDlgKeyWiz2)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

  _pPropSh = pPropSh;
}

CDlgKeyWiz2::~CDlgKeyWiz2()
{
}

void CDlgKeyWiz2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKeyWiz2)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
  CString str(_pPropSh->m_szKeyFile);
  DDX_Text(pDX, IDC_WIZKEYNAME, str);

}


BEGIN_MESSAGE_MAP(CDlgKeyWiz2, CPropertyPage)
	//{{AFX_MSG_MAP(CDlgKeyWiz2)
	ON_BN_CLICKED(IDC_ADDFILES, OnAddFiles)
	ON_BN_CLICKED(IDC_ADDRANDOM, OnAddRandom)
	ON_BN_CLICKED(IDC_KEYFILECREATE, OnKeyFileCreate)
	ON_BN_CLICKED(IDC_KEYFILEAPPEND, OnKeyfileAppend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgKeyWiz2 

BOOL CDlgKeyWiz2::OnSetActive() 
{
  _pPropSh->SetWizardButtons( PSWIZB_BACK | PSWIZB_NEXT);
	
	return CPropertyPage::OnSetActive();
}

void CDlgKeyWiz2::OnAddFiles() 
{
  CFileDialog FileDlg(TRUE,    //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask, //lpszDefExt        The default filename extension
                      "",      //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_IMPORTFILES);
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      CString  sFile;
      POSITION pos;
      TCHAR    buf [1024];
      int      nShowDragDropDlg = 0;

      for ( pos = FileDlg.GetStartPosition();
            pos != NULL;
            /* none */ ) 
      {
        sFile = FileDlg.GetNextPathName(pos);
        strcpy(buf, sFile);
        
        if (IsDirectory(buf))
          nShowDragDropDlg++;

        ListboxFillFiles(nShowDragDropDlg < 2, pListbox, "file: ", buf, &AppSettings, this);

      } // for all selected files

      UpdateKeySize();
    }
    
    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);
	
}

BOOL CDlgKeyWiz2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
  pListbox = (CListBox *)GetDlgItem(IDC_LISTKEYFILES);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgKeyWiz2::OnAddRandom() 
{
  CDlgKeyfileRnd dlgRnd(&AppSettings.lRndSeed, &AppSettings.lRndNum);

  if (dlgRnd.DoModal() == IDOK)
  {
    // In die Liste Parameter hinzufgen
    TCHAR buf[128];
    
    _stprintf(buf, "rnd: %lu %lu (%lu)", AppSettings.lRndSeed, AppSettings.lRndNum, AppSettings.lRndNum);
    pListbox->AddString(buf);
    UpdateKeySize();
  }
	
}


static long __cdecl AbortProc_KeyFileCreate(long lParam1, long lParam2, ABORT_PROC_DATA *pfData)
{
  char szBuf[256];
  sprintf(szBuf, "\nParameter: %d von %d\n\nOperation: \n%s\nBlock: %lu von %lu (%2.0f %%)", 
    (int)pfData->lData[0], 
    (int)pfData->lData[1], 
    (char *)pfData->lData[2],
    pfData->lData[3],
    pfData->lData[4],
    (float)((100.0 * pfData->lData[3]) / pfData->lData[4]) 
    );
  AbortSetText((HWND)lParam1, szBuf);
  return Abort((HWND)lParam1);
}


void CDlgKeyWiz2::KeyFileCreate(BOOL bAppend) 
{
  // Liste holen und auswerten
  int i;
  int nList = pListbox->GetCount();
  if (nList == 0)
  {
    MessageBeep(0);
    CString sErr((LPCSTR)IDS_ERROR);
    CString sMsg((LPCSTR)IDS_NOSRCFILES);
    MessageBox(sMsg, sErr, MB_ICONERROR | MB_OK);
    GetDlgItem(IDC_LISTKEYFILES)->SetFocus();
    return;
  }
  char **pList = (char **)MALLOC(nList * sizeof(char*));
  char *ch;
  if (pList != NULL)
  {
    int i;
    for (i=0; i < nList; i++) 
    {
      pList[i] = (char *)MALLOC(pListbox->GetTextLen(i) + 1);
      if (pList[i] != NULL)
        pListbox->GetText(i, pList[i]);
      else 
      {
        MessageBeep(0);
        return;
      }
      ch = strchr(pList[i], '(');
      if (ch != NULL) *ch = '\0';


    } // for i

  }
  
  CString sTitle((LPCSTR)IDS_INFOKEYCREATE);
  HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char*)(LPCSTR)sTitle, "");
  AbortDlgSetSize(hwndAbort, 400, 160);
  AbortAutoPlace(this->m_hWnd);

  ABORT_PROC_INFO AbortInfo;
  AbortInfo.lParam1 = (long)hwndAbort;
  AbortInfo.lParam2 = 0;
  AbortInfo.pfAbortProc = AbortProc_KeyFileCreate;

  if (!CreateKeyFile (bAppend, _pPropSh->m_szKeyFile, nList, pList, &AbortInfo))
  {
    // Fehlermeldung
    MessageBeep(0);
    CString sErr((LPCSTR)IDS_ERROR);
    CString sMsg((LPCSTR)IDS_ERRKEYCREATE);
    MessageBox(sMsg, sErr, MB_ICONERROR | MB_OK);
  }
  
  AbortRemove(hwndAbort);

  for (i=0; i < nList; i++)
    FREE(pList[i]);
  
  FREE(pList);
	
}

void CDlgKeyWiz2::OnKeyFileCreate() 
{
  KeyFileCreate(FALSE);
}

void CDlgKeyWiz2::OnKeyfileAppend() 
{
  KeyFileCreate(TRUE);
}

BOOL CDlgKeyWiz2::PreTranslateMessage(MSG* pMsg) 
{
  BOOL bTranslated = FALSE;

	switch (pMsg->message) 
  {
    case WM_DROPFILES:
      {
        HDROP hDrop = (HDROP)pMsg->wParam;
        TCHAR szFile[1024];
        UINT i, nszName, nFiles;
        int  nShowDragDropDlg = 0;

        nFiles = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
        for (i=0; i < nFiles; i++)
        {
          nszName = DragQueryFile(hDrop, i, szFile, sizeof(szFile)/sizeof(TCHAR));
          
          if (IsDirectory(szFile))
            nShowDragDropDlg++;
          
          ListboxFillFiles(nShowDragDropDlg < 2, pListbox, "file: ", szFile, &AppSettings, this);
        }
      
        DragFinish(hDrop);
        UpdateKeySize();
        return TRUE; // verarbeitet -> fertig.
      }
      break;
    
    case WM_KEYDOWN:
      {
        int nVirtKey = (int) pMsg->wParam;    // virtual-key code 
        if (nVirtKey == VK_DELETE)
        {
          if (GetFocus() == pListbox)
          {
            bTranslated = TRUE;

            int iIndex[1024], i, nSel;

            nSel = pListbox->GetSelItems(1024, iIndex);
            for (i=nSel-1; i>= 0; i--)
            {
              pListbox->DeleteString(iIndex[i]);
            }
            UpdateKeySize();
          }
        }

      }
      break;
    
  } // switch

	if (bTranslated) return TRUE;
  else return CPropertyPage::PreTranslateMessage(pMsg);
}


void CDlgKeyWiz2::UpdateKeySize(void)
{
  long nSize = 0;
  char *ch, szTmp[_MAX_PATH], chTmp[32];
  int i, nList = pListbox->GetCount();

  for (i=0; i < nList; i++) 
  {
    pListbox->GetText(i, szTmp);
   
    ch = strchr(szTmp, '(');
    if (ch != NULL) 
      nSize += atol(++ch);

  } // for i

  sprintf(szTmp, "%s (%s)", _pPropSh->m_szKeyFile, FormatLongToStr(nSize, chTmp));
  SetDlgItemText(IDC_WIZKEYNAME, szTmp);
}
