/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgKeyWiz3.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "Resource.h"
#include "DlgKeyWiz3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseite CDlgKeyWiz3 

CDlgKeyWiz3::CDlgKeyWiz3(CDlgKeyWizard *pPropSh) : CPropertyPage(CDlgKeyWiz3::IDD)
{
	//{{AFX_DATA_INIT(CDlgKeyWiz3)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

  _pPropSh = pPropSh;
}

CDlgKeyWiz3::~CDlgKeyWiz3()
{
}

void CDlgKeyWiz3::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKeyWiz3)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP

  char szTmp[_MAX_PATH], chTmp[32];
  sprintf(szTmp, "%s (%s)", _pPropSh->m_szKeyFile, FormatLongToStr(FileSize(_pPropSh->m_szKeyFile, NULL), chTmp));
  CString str(szTmp);
  DDX_Text(pDX, IDC_WIZKEYNAME, str);
}


BEGIN_MESSAGE_MAP(CDlgKeyWiz3, CPropertyPage)
	//{{AFX_MSG_MAP(CDlgKeyWiz3)
	ON_BN_CLICKED(IDC_MIXKEYFILE, OnMixKeyFile)
	ON_BN_CLICKED(IDC_REPEATLIMITER, OnRepeatLimiter)
	ON_BN_CLICKED(IDC_STATKEYFILE, OnStatKeyFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgKeyWiz3 

BOOL CDlgKeyWiz3::OnSetActive() 
{
  _pPropSh->SetWizardButtons( PSWIZB_BACK | PSWIZB_FINISH);
	
	return CPropertyPage::OnSetActive();
}


static long __cdecl AbortProc_KeyMixer(long lParam1, long lParam2, ABORT_PROC_DATA *pfData)
{
  char szBuf[256];
  sprintf(szBuf, "\nSchlsseldatei: %s\nFenstergre: %ld Bytes\nAnzahl Vertauschungen: %ld\nDurchlauf: %d von %d\nBlock: %ld von %ld (%2.0f %%)", 
    (char *)pfData->lData[6],
    pfData->lData[4], 
    pfData->lData[5], 
    (int)pfData->lData[0], 
    (int)pfData->lData[1], 
    pfData->lData[2], 
    pfData->lData[3],
    (float)((100.0 * pfData->lData[2]) / pfData->lData[3]) 
    );

  AbortSetText((HWND)lParam1, szBuf);
  return Abort((HWND)lParam1);
}


void CDlgKeyWiz3::OnMixKeyFile() 
{
  DlgMixKeyfile dlgMixKeyfile(&AppSettings.lRndSeed, &AppSettings.lMixNumWindow, &AppSettings.lMixNumExchg, &AppSettings.lMixNumPass);
	
  if (dlgMixKeyfile.DoModal() == IDOK)
  {
    CString sTitle((LPCSTR)IDS_INFOKEYMIX);
    HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char*)(LPCSTR)sTitle, "");
    AbortDlgSetSize(hwndAbort, 400, 150);
    AbortAutoPlace(this->m_hWnd);

    ABORT_PROC_INFO AbortInfo;
    AbortInfo.lParam1 = (long)hwndAbort;
    AbortInfo.lParam2 = 0;
    AbortInfo.pfAbortProc = AbortProc_KeyMixer;

    // Schlsseldatei mischen
    if (!MixKeyFile (_pPropSh->m_szKeyFile, AppSettings.lMixNumPass, AppSettings.lMixNumWindow, AppSettings.lMixNumExchg, &AppSettings.lRndSeed, &AbortInfo))
    {
      // Fehlermeldung
      MessageBeep(0);
      CString sErr((LPCSTR)IDS_ERROR);
      CString sMsg((LPCSTR)IDS_ERRKEYOP);
      MessageBox(sMsg, sErr);
    }
  
    AbortRemove(hwndAbort);
  }
	
}


static long __cdecl AbortProc_KeyRepeatLimiter(long lParam1, long lParam2, ABORT_PROC_DATA *pfData)
{
  char szBuf[256];
  sprintf(szBuf, "\nSchlsseldatei: %s\n\nFenstergrsse: %d Bytes\n\nBlock: %ld von %ld (%2.0f %%)", 
    (char *)pfData->lData[3],
    (int)pfData->lData[2], 
    pfData->lData[0], 
    pfData->lData[1],
    (float)((100.0 * pfData->lData[0]) / pfData->lData[1])
    );

  AbortSetText((HWND)lParam1, szBuf);
  return Abort((HWND)lParam1);
}


void CDlgKeyWiz3::OnRepeatLimiter() 
{
  CDlgRepLimKeyfile dlgRepLimKeyfile(&AppSettings.lRndSeed, &AppSettings.lRepLimWindow);
	
  if (dlgRepLimKeyfile.DoModal() == IDOK)
  {
    CString sTitle((LPCSTR)IDS_INFOKEYNORM);
    HWND hwndAbort  = AbortInstall(this->m_hWnd, FALSE, (char*)(LPCSTR)sTitle, "");
    AbortDlgSetSize(hwndAbort, 400, 150);
    AbortAutoPlace(this->m_hWnd);

    ABORT_PROC_INFO AbortInfo;
    AbortInfo.lParam1 = (long)hwndAbort;
    AbortInfo.lParam2 = 0;
    AbortInfo.pfAbortProc = AbortProc_KeyRepeatLimiter;

    // Wiederholungen eliminieren
    if (!RepeatLimiterKeyFile (_pPropSh->m_szKeyFile, AppSettings.lRepLimWindow, &AppSettings.lRndSeed, &AbortInfo))
    {
      // Fehlermeldung
      MessageBeep(0);
      CString sErr((LPCSTR)IDS_ERROR);
      CString sMsg((LPCSTR)IDS_ERRKEYOP);
      MessageBox(sMsg, sErr);
    }
  
    AbortRemove(hwndAbort);
  }
	
}

void CDlgKeyWiz3::OnStatKeyFile() 
{
  STATINFO sd, sh;
  BOOL     bRet;
  
  theApp.BeginWaitCursor();
  
  // Statistik ermitteln
  bRet = KeyFileStat (_pPropSh->m_szKeyFile, &sd, &sh);
  
  theApp.EndWaitCursor();

  if (bRet)
  {
    CString sMsg1((LPCSTR)IDS_STATDATA);
    MessageBoxStatisticsXY(this->m_hWnd, sMsg1, &sd);

    CString sMsg2((LPCSTR)IDS_STATHISTO);
    MessageBoxStatisticsX(this->m_hWnd,  sMsg2, &sh);

  } else MessageBeep(0);	
	
}

BOOL CDlgKeyWiz3::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
/*
  char szTmp[_MAX_PATH], chTmp[32];
  sprintf(szTmp, "%s (%s)", _pPropSh->m_szKeyFile, FormatLongToStr(FileSize(_pPropSh->m_szKeyFile, NULL), chTmp));
  SetDlgItemText(IDC_WIZKEYNAME, szTmp);
*/	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}
