/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgLicenseWiz2.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "DlgLicenseWiz2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Eigenschaftenseite CDlgLicenseWiz2 

CDlgLicenseWiz2::CDlgLicenseWiz2(CDlgLicenseWizard *pPropSh) : CPropertyPage(CDlgLicenseWiz2::IDD)
{
	//{{AFX_DATA_INIT(CDlgLicenseWiz2)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

  _pPropSh = pPropSh;
}

CDlgLicenseWiz2::~CDlgLicenseWiz2()
{
}

void CDlgLicenseWiz2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLicenseWiz2)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgLicenseWiz2, CPropertyPage)
	//{{AFX_MSG_MAP(CDlgLicenseWiz2)
		// HINWEIS: Der Klassen-Assistent fgt hier Zuordnungsmakros fr Nachrichten ein
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgLicenseWiz2 

BOOL CDlgLicenseWiz2::OnSetActive() 
{
  _pPropSh->SetWizardButtons( PSWIZB_BACK | PSWIZB_FINISH);
	
	return CPropertyPage::OnSetActive();
  
}

BOOL CDlgLicenseWiz2::OnWizardFinish() 
{
  if (!AllRadioButtonSelected())
  {
    MessageBeep(0);
    MessageBox(CString((LPCSTR)IDS_LICENSEANSWERQUESTIONS), CString((LPCSTR)IDS_ERROR), MB_OK | MB_ICONSTOP);
    return FALSE;
  }
	_pPropSh->Answer = GetAnswers();
  
	return CPropertyPage::OnWizardFinish();
}

BOOL CDlgLicenseWiz2::AllRadioButtonSelected(void)
{
  if (!(IsDlgButtonChecked(IDC_QY1) || IsDlgButtonChecked(IDC_QN1))) return FALSE;
  if (!(IsDlgButtonChecked(IDC_QY2) || IsDlgButtonChecked(IDC_QN2))) return FALSE;
  if (!(IsDlgButtonChecked(IDC_QY3) || IsDlgButtonChecked(IDC_QN3))) return FALSE;
  if (!(IsDlgButtonChecked(IDC_QY4) || IsDlgButtonChecked(IDC_QN4))) return FALSE;
  if (!(IsDlgButtonChecked(IDC_QY5) || IsDlgButtonChecked(IDC_QN5))) return FALSE;
  if (!(IsDlgButtonChecked(IDC_QY6) || IsDlgButtonChecked(IDC_QN6))) return FALSE;

  return TRUE;
}

int CDlgLicenseWiz2::GetAnswers(void)
{
  int a = 0;

  if (IsDlgButtonChecked(IDC_QY1)) a |= 1 << 0;
  if (IsDlgButtonChecked(IDC_QY2)) a |= 1 << 1;
  if (IsDlgButtonChecked(IDC_QY3)) a |= 1 << 2;
  if (IsDlgButtonChecked(IDC_QY4)) a |= 1 << 3;
  if (IsDlgButtonChecked(IDC_QY5)) a |= 1 << 4;
  if (IsDlgButtonChecked(IDC_QY6)) a |= 1 << 5;

  return a;
}
