/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgMixKeyfile.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "DlgMixKeyfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld DlgMixKeyfile 


DlgMixKeyfile::DlgMixKeyfile(long *rnd, long *nWindowSize, long *nWindowPass, long *nPass, CWnd* pParent /*=NULL*/)
	: CDialog(DlgMixKeyfile::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgMixKeyfile)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT

  _rnd          = rnd;         // Referenz auf Zufallsvariable
  _nWindowSize  = nWindowSize; // Fenstergrsse in Bytes
  _nWindowPass  = nWindowPass; // Anzahl der Vertauschungen innerhalb des Fensters
  _nPass        = nPass;       // Anzahl der Durchlufe (Datei)
}


void DlgMixKeyfile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgMixKeyfile)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgMixKeyfile, CDialog)
	//{{AFX_MSG_MAP(DlgMixKeyfile)
	ON_BN_CLICKED(IDC_SETRND, OnSetRnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten DlgMixKeyfile 

BOOL DlgMixKeyfile::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  SetDlgItemInt(IDC_RNDVAL,     *_rnd,    FALSE );
  SetDlgItemInt(IDC_WINDOWSIZE, *_nWindowSize, FALSE );
  SetDlgItemInt(IDC_WINDOWPASS, *_nWindowPass, FALSE );
  SetDlgItemInt(IDC_NUMPASS,    *_nPass, FALSE );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void DlgMixKeyfile::OnOK() 
{
	*_rnd         = GetDlgItemInt(IDC_RNDVAL,     NULL, FALSE);
  *_nWindowSize = GetDlgItemInt(IDC_WINDOWSIZE, NULL, FALSE);
  *_nWindowPass = GetDlgItemInt(IDC_WINDOWPASS, NULL, FALSE);
  *_nPass       = GetDlgItemInt(IDC_NUMPASS,    NULL, FALSE);
	
	CDialog::OnOK();
}

void DlgMixKeyfile::OnSetRnd() 
{
  long rnd = GetTickCount();
 
  SetDlgItemInt(IDC_RNDVAL, LongRnd(&rnd), FALSE);
}
