/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// DlgSettings.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OneTimePad.h"
#include "DlgSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgSettings 


CDlgSettings::CDlgSettings(APPSETTINGS *pSettings, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSettings)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
  m_pSettings = pSettings;
}


void CDlgSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSettings)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSettings, CDialog)
	//{{AFX_MSG_MAP(CDlgSettings)
	ON_BN_CLICKED(IDC_DEFAULT, OnDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgSettings 

void CDlgSettings::OnDefault() 
{
  SetDlgItemText(IDC_DECRYPTPREFIX, DEFAULT_DECODEPREFIX);
  SetDlgItemText(IDC_CIPHERSUFFIX,  DEFAULT_CIPHERSUFFIX);
  SetDlgItemText(IDC_ASCIISUFFIX,   DEFAULT_ASCIISUFFIX);
  SetDlgItemInt(IDC_RNDMUL, LONGRND_MUL, FALSE);
  SetDlgItemInt(IDC_RNDADD, LONGRND_ADD, FALSE);
  CheckDlgButton(IDC_CRYPTDELETE,   0);
  CheckDlgButton(IDC_CONSUMEKEY,    0);
	
}

BOOL CDlgSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  SetDlgItemText(IDC_DECRYPTPREFIX, m_pSettings->szDecodePrefix);
  SetDlgItemText(IDC_CIPHERSUFFIX,  m_pSettings->szCipherSuffix);
  SetDlgItemText(IDC_ASCIISUFFIX,   m_pSettings->szAsciiSuffix);
  SetDlgItemInt(IDC_RNDMUL,         m_pSettings->lRndMul, FALSE);
  SetDlgItemInt(IDC_RNDADD,         m_pSettings->lRndAdd, FALSE);
  CheckDlgButton(IDC_CRYPTDELETE,   m_pSettings->bDeleteafterOperation ? 1 : 0);
  CheckDlgButton(IDC_CONSUMEKEY,    m_pSettings->bConsumeKey ? 1 : 0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgSettings::OnOK() 
{
  GetDlgItemText(IDC_DECRYPTPREFIX, m_pSettings->szDecodePrefix, sizeof(m_pSettings->szDecodePrefix));
  GetDlgItemText(IDC_CIPHERSUFFIX,  m_pSettings->szCipherSuffix, sizeof(m_pSettings->szCipherSuffix));
  GetDlgItemText(IDC_ASCIISUFFIX,   m_pSettings->szAsciiSuffix,  sizeof(m_pSettings->szAsciiSuffix));
  m_pSettings->lRndMul = GetDlgItemInt(IDC_RNDMUL);
  m_pSettings->lRndAdd = GetDlgItemInt(IDC_RNDADD);
  m_pSettings->bDeleteafterOperation = IsDlgButtonChecked(IDC_CRYPTDELETE);
  m_pSettings->bConsumeKey           = IsDlgButtonChecked(IDC_CONSUMEKEY);
	
	CDialog::OnOK();
}
