/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

/* LongMath.h */

#ifndef __INC_LONGMATH__
#define __INC_LONGMATH__

#include <windows.h>

#ifdef __cplusplus
extern "C" { // Assume C declarations for C++
#endif       // __cplusplus

//-----------------------------------------------------------------------------------

#define LONGRND_MAXRAND      0x7FFFFFFF

// IBM-Random (Parameter)
//#define LONGRND_MUL          123456789L
//#define LONGRND_ADD          453816691L

// Aziz-Random Parameter (Primzahlen!)
#define LONGRND_MUL          254327641L
#define LONGRND_ADD          665238751L

//-----------------------------------------------------------------------------------
// Zufallszahlengenerator

void WINAPI LongRndInit(long lMul, long lAdd);
long WINAPI LongRnd    (long far *rndval);
long WINAPI LongRandom (long far *rndval, long max);

//-----------------------------------------------------------------------------------
// Primzahlengenerator

BOOL WINAPI IsPrime    (long p, long sqrtp);
long WINAPI NextPrime  (long p);
long WINAPI PrevPrime  (long p);

//-----------------------------------------------------------------------------------

#ifdef __cplusplus
}       // End of extern "C" {
#endif  // __cplusplus

//-----------------------------------------------------------------------------------

#endif  //ifndef __INC_LONGMATH__
