/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

/* Memalloc.h : Memory allocation debug utilities */

#ifndef __INC_MEMALLOC__
#define __INC_MEMALLOC__

#ifdef __cplusplus
extern "C" { // Assume C declarations for C++
#endif       // __cplusplus 

//-----------------------------------------------------------------------------------

#ifdef MALLOC_DEBUG

void * WINAPI dbg_malloc(LONG s);
void   WINAPI dbg_free(void *);

#define MALLOC(s)       dbg_malloc((LONG)(s))
#define FREE(p)         dbg_free(p)

#else // MALLOC_DEBUG

#define MALLOC(s)       malloc(s)
#define FREE(p)         free(p)

#endif // MALLOC_DEBUG

//-----------------------------------------------------------------------------------

#define GETPTR(Base, Ofs)   ( (LPBYTE)(Base)+(long)(Ofs) )
#define MEMCMP_EQ(dst, src, cb) ( memcmp(dst, src, cb) == 0)
#define MEMCMP_NE(dst, src, cb) ( memcmp(dst, src, cb) != 0)
#define MEMSET(dst, val, cb)      memset(dst, val, cb)
#define MEMCPY(dst, src, cb)      memcpy(dst, src, cb)

//-----------------------------------------------------------------------------------

#ifdef __cplusplus
}       // End of extern "C" {
#endif  // __cplusplus

//-----------------------------------------------------------------------------------

#endif // __INC_MEMALLOC__
