/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// OneTimePadDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Resource.h"
#include "OneTimePad.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyOneTimePadDlg Dialogfeld

CMyOneTimePadDlg::CMyOneTimePadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyOneTimePadDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyOneTimePadDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyOneTimePadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyOneTimePadDlg)
		// HINWEIS: Der Klassenassistent fgt an dieser Stelle DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyOneTimePadDlg, CDialog)
	//{{AFX_MSG_MAP(CMyOneTimePadDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_KEYBUILDER, OnKeybuilder)
	ON_BN_CLICKED(IDC_BROWSEKEYFILE, OnBrowseKeyfile)
	ON_BN_CLICKED(IDC_BUTTONCIPHER, OnButtonCipher)
	ON_BN_CLICKED(IDC_BUTTONDECRYPT, OnButtonDecode)
	ON_COMMAND(IDM_CLEAR, OnClear)
	ON_COMMAND(IDM_PASTE, OnPaste)
	ON_COMMAND(IDM_CUT, OnCut)
	ON_COMMAND(IDM_COPY, OnCopy)
	ON_COMMAND(IDM_MARKALL, OnMarkAll)
	ON_COMMAND(IDM_CLOSE, OnClose)
	ON_CBN_SELCHANGE(IDC_COMBOKEY, OnSelchangeCombokey)
	ON_COMMAND(IDM_CONVTOASCII, OnConvtoAscii)
	ON_COMMAND(IDM_CONVTOBIN, OnConvtoBin)
	ON_COMMAND(IDM_CRYPTBIN, OnCryptBin)
	ON_COMMAND(IDM_CRYPTASCII, OnCryptAscii)
	ON_COMMAND(IDM_DECODEBIN, OnDecodeBin)
	ON_COMMAND(IDM_DECODEASCII, OnDecodeAscii)
	ON_COMMAND(IDM_LOADTEXT, OnLoadText)
	ON_COMMAND(IDM_SAVETEXT, OnSaveText)
	ON_COMMAND(IDM_UNDO, OnUndo)
	ON_COMMAND(IDM_ABOUTBOX, OnAboutBox)
	ON_COMMAND(IDM_RANDOMTEST, OnRandomTest)
	ON_COMMAND(IDM_EINSTELLUNGEN, OnEinstellungen)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
  ON_WM_INITMENU()
	ON_COMMAND(IDM_ENTSCHLUESSELN, OnEntschluesseln)
	ON_COMMAND(IDM_VERSCHLUESSELN, OnVerschluesseln)
	//ON_COMMAND(IDM_TEXTMODE, OnTextMode)
	//ON_COMMAND(IDM_FILEMODE, OnFileMode)
	//ON_BN_CLICKED(IDC_BROWSEFILES, OnBrowseFiles)
	ON_WM_DESTROY()
	ON_COMMAND(IDM_TEST, OnTest)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_COMMAND(IDM_LICENSE, OnLicense)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//-----------------------------------------------------------------------------

char *RemoveSuffix(char *szSrc, const char *szSuffix)
{
  // Suffix rausnehmen, wenn exakt gefunden
  int l = strlen(szSrc);
  int sn = strlen(szSuffix);
  int i, n;

  if (l < sn) return szSrc;

  for (n = 0, i = l - sn; n < sn; n++,i++)
  {
    if (toupper(szSrc[i]) != toupper(szSuffix[n]) ) 
      return szSrc;
  }
  
  szSrc[l - sn] = '\0';
  return szSrc;
}

//-----------------------------------------------------------------------------

char *MakeFName(char *szSrc, char *szDst, const char *szPrefix, const char *szSuffix)
{
  char szDrv[_MAX_DRIVE];
  char szDir[_MAX_DIR];
  char szFname[_MAX_FNAME];
  char szFname2[_MAX_FNAME];
  char szExt[_MAX_EXT];
  char szTmp[_MAX_PATH];

  strcpy(szTmp, szSrc);
  RemoveSuffix(szTmp, szSuffix);
  _splitpath(szTmp, szDrv, szDir, szFname, szExt); 
  
  // Prefix an den Dateinamen voranstellen
  strcpy(szFname2, szPrefix);
  strcat(szFname2, szFname);
  
  // Neuen Dateinamen zusammenfgen
  _makepath(szDst, szDrv, szDir, szFname2, szExt);
  
  return szDst;
}

//-----------------------------------------------------------------------------

char *GetFMask(char *szDst, char *szMask)
{
  sprintf(szDst, "*%s", szMask);
  
  return szDst;
}

//-----------------------------------------------------------------------------

char *GetFMask2(char *szDst, char *szName, char *szMask)
{
  sprintf(szDst, "%s (*%s)|*%s|", szName, szMask, szMask);
  
  return szDst;
}

//-----------------------------------------------------------------------------


/////////////////////////////////////////////////////////////////////////////
// CMyOneTimePadDlg Nachrichten-Handler

BOOL CMyOneTimePadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
  CString s((LPCSTR)IDS_APP);
  SetWindowText(s); 

  // ComboBox
  UpdateKeyStreamPopup();

  CEdit *pText = (CEdit *)GetDlgItem(IDC_EDITTEXT);
  pStatus = (CStatic *)GetDlgItem(IDC_STATUS);

  SetStatusText(CString((LPCSTR)IDS_READY));

/*
  HLOCAL lMem = LocalAlloc(LMEM_MOVEABLE, 128000);
  if (lMem != NULL)
  {
    LocalFree(pText->GetHandle());
    pText->SetHandle(lMem);
    pText->SetLimitText(128000);
  }

  UINT nn = pText->GetLimitText();
*/
  pText->SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_FIXED_FONT)), TRUE);
  pText->SetFocus();
  
  CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);
  pListbox->SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_FIXED_FONT)), TRUE);

  // Anwendungsmodus setzen
  //SetMode(AppSettings.nViewMode);

  // Kontrollelemente automatisch positionieren
  RECT rc;
  if (theApp.LoadWindowPos(rc))
  {  
    SetWindowPos(NULL, rc.left, rc.top, rc.right, rc.bottom, SWP_NOZORDER | SWP_SHOWWINDOW /*| SWP_NOSENDCHANGING*/);
  } else MoveWindow(0, 0, 500, 500, TRUE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//-----------------------------------------------------------------------------
// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CMyOneTimePadDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//-----------------------------------------------------------------------------
// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CMyOneTimePadDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//-----------------------------------------------------------------------------

BOOL CMyOneTimePadDlg::PreTranslateMessage(MSG* pMsg) 
{
  if (pMsg->message == WM_DROPFILES)
  {
    CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);

    if (pListbox->m_hWnd == pMsg->hwnd)
    {
      HDROP hDrop = (HDROP)pMsg->wParam;
      TCHAR szFile[1024];
      UINT i, nFiles;

      nFiles = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
      for (i=0; i < nFiles; i++)
      {
        DragQueryFile(hDrop, i, szFile, sizeof(szFile)/sizeof(TCHAR));
        ListboxFillFiles(TRUE, pListbox, "", szFile, &AppSettings, this);
      }
  
      DragFinish(hDrop);
      return TRUE; // verarbeitet -> fertig.
    }

  } else if (pMsg->message == WM_KEYDOWN) 
  {
    switch (pMsg->wParam) {

      case VK_ESCAPE:
        return TRUE;
      
      case VK_DELETE:
        {
          CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);
          if (GetFocus() == pListbox)
          {
            int iIndex[1024], i, nSel;

            nSel = pListbox->GetSelItems(1024, iIndex);
            for (i=nSel-1; i>= 0; i--)
            {
              pListbox->DeleteString(iIndex[i]);
            }
            return TRUE;
          }
        }
        break;

      case VK_RETURN:
        {
          CComboBox *pCntr = (CComboBox *)GetDlgItem(IDC_COMBOKEY);

          if (pCntr->m_hWnd == pMsg->hwnd)
          {
            pCntr->ShowDropDown(FALSE);
            GetDlgItem(IDC_EDITTEXT)->SetFocus();

            return TRUE;
          }
        }
        break;
        
    } // switch
  }

  if( IsDialogMessage( pMsg ) )
        return TRUE;
    else
        return CWnd::PreTranslateMessage( pMsg );
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnBrowseKeyfile() 
{
  CFileDialog FileDlg(TRUE,          //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szKeyFileMask, //lpszDefExt        The default filename extension
                      "",            //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES, 
                      szKeyFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 1024;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_SELKEYFILE);    
    strcpy(FileDlg.m_ofn.lpstrFile, AppSettings.KeyFileHistory[0].szKeyFile);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      CString sFile;
      char    szFile[_MAX_PATH];

      //theApp.BeginWaitCursor();

      sFile = FileDlg.GetPathName();
      strcpy(szFile, sFile);

      //todo: bConsumeKey im Popup signalisieren
      
      theApp.AddKeyFiletoHistory(szFile);
      UpdateKeyStreamPopup();
      
      CheckRWKeyFile(&AppSettings.KeyFileHistory[0]);
      
      theApp.SaveSettings();

      //theApp.EndWaitCursor();

    }
    
    FREE(FileDlg.m_ofn.lpstrFile);
  
  } else MessageBeep(0);

  SetStatusText(CString((LPCSTR)IDS_READY));
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnCipherText() 
{
  CEdit *pTextCtrl;
  int    nText;

  pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);

  nText = pTextCtrl->GetWindowTextLength();
  if (nText != 0)
  { 
    if (OverflowKeyStream(nText, &AppSettings.KeyFileHistory[0]))
    {
      return;
    }

    char szPwd[MAX_PWD_SIZE+1];
		CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
		
    if (dlgKey.DoModal() != IDOK)
    {
      MessageBeep(0);
      return;
    }
    
    int    nBuffer = max(256, nText*2);
    char  *pText   = (char *) MALLOC(nBuffer);
    char  *pTmp    = (char *) MALLOC(nBuffer);
    char  *aLut = GetStatic6BitLut();
    char  *ch;
    int    i, n, k, m;

    if (pText != NULL && pTmp != NULL)
    {
      // Text holen
      n = pTextCtrl->GetWindowText(pText, nText+1);
      if (n < 0) n += 65536; // Scheiss 16-Bit-Rest

      // Text verschlsseln
      n = EncodeBuffer(TRUE, AppSettings.bConsumeKey, szPwd, n, pText, pTmp, &AppSettings.KeyFileHistory[0]);
      
      // Code in 6-Bit ASCII umwandeln
      k = Convert8to6Bit(n, pTmp, pText);
      Convert6toASCII(aLut, k, pText, pTmp);
      pTmp[k] = '\0';

      ch = pText;
      for (i = n = 0; i < k; i+= MAX_PER_LINE_ASCII)
      {
        m = min(MAX_PER_LINE_ASCII, k-i);
        
        memcpy(ch, &pTmp[i], m);
        ch[m++] = 0x0d;
        ch[m++] = 0x0a;
        ch += m;
        n  += m;
      }
      *ch = '\0';

      // Code ausgeben
      m = pTextCtrl->GetLimitText();
      if (n > m)
      {
        MessageBeep(0);
        CString sErr((LPCSTR)IDS_ERROR);
        CString sMsg((LPCSTR)IDS_TEXTTOLONG);
        MessageBox(sMsg, sErr, MB_OK | MB_ICONEXCLAMATION );
        pText[m] = '\0';
        
        SetStatusText(CString((LPCSTR)IDS_TEXTOVERFLOW));

      } else SetStatusText(CString((LPCSTR)IDS_READY));

      pTextCtrl->SetSel(0, nText, FALSE);
      pTextCtrl->ReplaceSel(pText);
      pTextCtrl->SetFocus();

    } else 
    {
      MessageBeep(0);
      SetStatusText(CString((LPCSTR)IDS_STERROR));
    
    }

    if (pText != NULL) FREE(pText);
    if (pTmp  != NULL) FREE(pTmp);
  } 
  
  UpdateKeyStreamPopup();
  pTextCtrl->SetFocus();

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnDecodeText() 
{
  CEdit *pTextCtrl;
  int    nText;

  pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
  
  nText = pTextCtrl->GetWindowTextLength();
  if (nText != 0)
  { 
    char szPwd[MAX_PWD_SIZE+1];
		CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
		
    if (dlgKey.DoModal() != IDOK)
    {
      MessageBeep(0);
      return;
    }

    int    nBuffer = max(256, nText+1);
    char  *pText   = (char *) MALLOC(nBuffer);
    char  *pTmp    = (char *) MALLOC(nBuffer);
    char  *aLut    = GetStaticInvLut();
    int   n, k, m;

    if (pText != NULL && pTmp != NULL)
    {
      // Verschlsselten Text holen
      n = pTextCtrl->GetWindowText(pText, nText+1);
      if (n < 0) n += 65536; // Scheiss 16-Bit-Rest

      // Von ASCII in Codes umwandeln
      n = ConvertASCIIto6(aLut, n, pText, pTmp);
      k = Convert6to8Bit(n, pTmp, pText);

      // Text entschlsseln
      k = EncodeBuffer  (FALSE, AppSettings.bConsumeKey, szPwd, k, pText, pTmp, &AppSettings.KeyFileHistory[0]);

      // Entschlsselten Text ins Textfeld laden
      pTmp[k] = '\0';

      // Textfeld lschen
      m = pTextCtrl->GetWindowTextLength();
      pTextCtrl->SetSel(0, m, FALSE);
      pTextCtrl->ReplaceSel(pTmp);
      
      SetStatusText(CString((LPCSTR)IDS_READY));

    } else 
    {
      MessageBeep(0);
      SetStatusText(CString((LPCSTR)IDS_STERROR));
    }

    if (pText != NULL) FREE(pText);
    if (pTmp  != NULL) FREE(pTmp);
  }
  
  UpdateKeyStreamPopup();
  pTextCtrl->SetFocus();
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnClear() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
    int    nText     = pTextCtrl->GetWindowTextLength();

    // Textfeld lschen
    pTextCtrl->SetSel(0, nText, TRUE);
    pTextCtrl->ReplaceSel("");
    pTextCtrl->SetFocus();
//  } else 
//  {
//    CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);

//    // Listbox lschen
//    pListbox->ResetContent();
//    pListbox->SetFocus();
//  }
  
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnUndo() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);

    pTextCtrl->Undo();

//  } else MessageBeep(0);
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnPaste() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);

    pTextCtrl->Paste();
    pTextCtrl->SetFocus();

//  } else MessageBeep(0);
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnCopy() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
    int    nText     = pTextCtrl->GetWindowTextLength();

    // Textfeld lschen
    pTextCtrl->SetSel(0, nText, TRUE);
    pTextCtrl->Copy();
    pTextCtrl->SetFocus();

//  } else MessageBeep(0);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnMarkAll() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
    int    nText     = pTextCtrl->GetWindowTextLength();

    // Textfeld markieren
    pTextCtrl->SetSel(0, nText, TRUE);

    pTextCtrl->SetFocus();
//  } else 
//  {
//    CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);
//    int i, nList = pListbox->GetCount();

//    // Listbox markieren 
//    for (i=0; i < nList; i++)
//      pListbox->SetSel(i, TRUE);

//    pListbox->SetFocus();
//  }

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnCut() 
{
//  if (AppSettings.nViewMode == 0)
//  {
    CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);

    pTextCtrl->Cut();

//  } else MessageBeep(0);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnClose() 
{
  EndDialog(IDOK);
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::UpdateKeyStreamPopup()
{
  CComboBox *pComboKey = (CComboBox *)GetDlgItem(IDC_COMBOKEY);
  char szTmp[_MAX_PATH + 128], szIndex[32], szSize[32];
  int  i;
  long fSize, Index;
  double nProz;

  pComboKey->ResetContent();

  for (i = 0; i < AppSettings.nKeyFiles; i++)
  {
    fSize = FileSize(AppSettings.KeyFileHistory[i].szKeyFile, &AppSettings.KeyFileHistory[i].bRW);
    AppSettings.KeyFileHistory[i].nSize = fSize;
    Index = AppSettings.KeyFileHistory[i].nIndex;
    nProz = 0.0;

    if (fSize != 0)
      nProz = (double)(100.0 * Index) / (double)fSize;

    sprintf(szTmp, "%s (%s / %s, %5.2f%%%s)", 
                   AppSettings.KeyFileHistory[i].szKeyFile, 
                   FormatLongToStr(Index, szIndex), 
                   FormatLongToStr(fSize, szSize), 
                   nProz, 
                   AppSettings.KeyFileHistory[i].bRW ? "" : " - rd"
                   );
    pComboKey->AddString(szTmp);    

  } // for i

  pComboKey->SetCurSel(0);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnSelchangeCombokey() 
{
  char szKeyFile[_MAX_PATH];
  char *sz;
  CComboBox *pComboKey = (CComboBox *)GetDlgItem(IDC_COMBOKEY);
  int nSel = pComboKey->GetCurSel();

  pComboKey->GetLBText(nSel, szKeyFile);

  // Lnge in Klammern entfernen
  sz = strstr(szKeyFile, " (");
  if (sz != NULL) *sz = '\0';

  // Schlsseldatei in die Historyliste setzen
  theApp.AddKeyFiletoHistory(szKeyFile);

  CheckRWKeyFile(&AppSettings.KeyFileHistory[0]);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnConvtoAscii() 
{
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask,  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_ENCODEASCII);
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szSrc[_MAX_PATH];
      char szDst[_MAX_PATH];
      CString sFile;
      POSITION pos;
      BOOL  bDelete = FALSE;

      if (AppSettings.bDeleteafterOperation) 
        bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

      theApp.BeginWaitCursor();

      for ( pos = FileDlg.GetStartPosition();
            pos != NULL;
            /* none */ ) 
      {
        sFile = FileDlg.GetNextPathName(pos);

        strcpy(szSrc, sFile);
        strcpy(szDst, szSrc);
        strcat(szDst, AppSettings.szAsciiSuffix);

        if (ConvertBin2ASCII (szSrc, szDst))
        {
          if (bDelete)
            EraseFile(szSrc, TRUE);

        } else 
        {
          MessageBeep(0);
          
          char szMsg[_MAX_PATH+128];
          sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
          
          if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
          { 
            //bAbort = TRUE;
            break;
          }
        }

      } // for all selected files

      theApp.EndWaitCursor();

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnConvtoBin() 
{
  char szMask1[128], szMask2[128];
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      GetFMask(szMask1, AppSettings.szAsciiSuffix),  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      GetFMask2(szMask2, "ASCII 6-Bit Dateien", AppSettings.szAsciiSuffix), 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_DECODEASCII);
    GetFMask(FileDlg.m_ofn.lpstrFile, AppSettings.szAsciiSuffix);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szSrc[_MAX_PATH];
      char szDst[_MAX_PATH];
      CString sFile;
      POSITION pos;
      BOOL  bDelete = FALSE;

      if (AppSettings.bDeleteafterOperation) 
        bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

      theApp.BeginWaitCursor();

      for ( pos = FileDlg.GetStartPosition();
            pos != NULL;
            /* none */ ) 
      {
        sFile = FileDlg.GetNextPathName(pos);

        strcpy(szSrc, sFile);
        MakeFName(szSrc, szDst, AppSettings.szDecodePrefix, AppSettings.szAsciiSuffix);

        if (ConvertASCII2Bin (szSrc, szDst))
        {
          if (bDelete)
            EraseFile(szSrc, TRUE);

        } else 
        {
          MessageBeep(0);
          
          char szMsg[_MAX_PATH+128];
          sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
          
          if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
          { 
            //bAbort = TRUE;
            break;
          }
        }

      } // for all selected files

      theApp.EndWaitCursor();

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

}

//-----------------------------------------------------------------------------

void CAboutDlg::OnOK() 
{
  CDialog::OnOK();
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnCryptBin() 
{
  BOOL bAbort = FALSE;
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask,  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_CIPHERBINFILE);
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szPwd[MAX_PWD_SIZE+1];
	    CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
	    
      if (dlgKey.DoModal() == IDOK)
      {
        char szSrc[_MAX_PATH];
        char szDst[_MAX_PATH];
        CString sFile;
        POSITION pos;
        BOOL  bDelete = FALSE;

        if (AppSettings.bDeleteafterOperation) 
          bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

        HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char *)(LPCTSTR)CString((LPCSTR)IDS_CRYPTING), "");
        AbortDlgSetSize(hwndAbort, 400, 130);
        AbortAutoPlace(this->m_hWnd);

        theApp.BeginWaitCursor();

        for ( pos = FileDlg.GetStartPosition();
              pos != NULL;
              /* none */ ) 
        {
          sFile = FileDlg.GetNextPathName(pos);

          strcpy(szSrc, sFile);
          strcpy(szDst, szSrc);
          strcat(szDst, AppSettings.szCipherSuffix);
          {
            char szMsg[_MAX_PATH+128];

            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_CRYPTINGFILE), szSrc);
            AbortSetText(hwndAbort, szMsg);
            bAbort |= Abort(hwndAbort);
            if (bAbort)
              break; // Abbruch
          }
 
          if (OverflowKeyStream(FileSize(szSrc, NULL), &AppSettings.KeyFileHistory[0]))
          {
            bAbort = TRUE;
            break; // break for pos
          }

          if (EncodeFile (TRUE,  AppSettings.bConsumeKey, szPwd, szSrc, szDst, &AppSettings.KeyFileHistory[0]) )
          {
            if (bDelete)
              EraseFile(szSrc, TRUE);

          } else 
          {
            MessageBeep(0);
            
            char szMsg[_MAX_PATH+128];
            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
            
            if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
            { 
              bAbort = TRUE;
              break;
            }

          }

        } // for all selected files

        theApp.EndWaitCursor();
        
        AbortRemove(hwndAbort);
      
      } else  MessageBeep(0);

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

  if (bAbort) SetStatusText(CString((LPCSTR)IDS_ABORT));
  else        SetStatusText(CString((LPCSTR)IDS_READY));

  UpdateKeyStreamPopup();
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnDecodeBin() 
{
  BOOL bAbort = FALSE;
  char szMask1[128], szMask2[128];
  CString sCryptFiles((LPCSTR)IDS_CRYPTFILES);
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      GetFMask(szMask1, AppSettings.szCipherSuffix),  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      GetFMask2(szMask2, (char *)(LPCSTR)sCryptFiles, AppSettings.szCipherSuffix), 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_DECODEBINFILE);
    GetFMask(FileDlg.m_ofn.lpstrFile, AppSettings.szCipherSuffix);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szPwd[MAX_PWD_SIZE+1];
	    CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
	    
      if (dlgKey.DoModal() == IDOK)
      {
        char szSrc[_MAX_PATH];
        char szDst[_MAX_PATH];
        CString sFile;
        POSITION pos;
        BOOL  bDelete = FALSE;

        if (AppSettings.bDeleteafterOperation) 
          bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

        HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char *)(LPCTSTR)CString((LPCSTR)IDS_DECRYPTING), "");
        AbortDlgSetSize(hwndAbort, 400, 130);
        AbortAutoPlace(this->m_hWnd);

        theApp.BeginWaitCursor();

        for ( pos = FileDlg.GetStartPosition();
              pos != NULL;
              /* none */ ) 
        {
          sFile = FileDlg.GetNextPathName(pos);

          strcpy(szSrc, sFile);
          MakeFName(szSrc, szDst, AppSettings.szDecodePrefix, AppSettings.szCipherSuffix);

          {
            char szMsg[_MAX_PATH+128];

            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_DECRYPTINGFILE), szSrc);
            AbortSetText(hwndAbort, szMsg);
            bAbort |= Abort(hwndAbort);
            if (bAbort)
              break; // Abbruch
          }

          if (EncodeFile (FALSE,  AppSettings.bConsumeKey, szPwd, szSrc, szDst, &AppSettings.KeyFileHistory[0]) )
          {
            if (bDelete)
              EraseFile(szSrc, TRUE);

          } else 
          {
            MessageBeep(0);
            
            char szMsg[_MAX_PATH+128];
            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
            
            if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
            { 
              bAbort = TRUE;
              break;
            }
          }

        } // for all selected files

        theApp.EndWaitCursor();

        AbortRemove(hwndAbort);
      
      } else  MessageBeep(0);

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

  if (bAbort) SetStatusText(CString((LPCSTR)IDS_ABORT));
  else        SetStatusText(CString((LPCSTR)IDS_READY));

  UpdateKeyStreamPopup();

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnCryptAscii() 
{
  BOOL bAbort = FALSE;
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask,  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_CIPHERASCIIFILE);
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szPwd[MAX_PWD_SIZE+1];
	    CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
	    
      if (dlgKey.DoModal() == IDOK)
      {
        char szSrc[_MAX_PATH];
        char szDst[_MAX_PATH];
        CString sFile;
        POSITION pos;
        BOOL  bDelete = FALSE;

        if (AppSettings.bDeleteafterOperation) 
          bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

        HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char *)(LPCTSTR)CString((LPCSTR)IDS_CRYPTING), "");
        AbortDlgSetSize(hwndAbort, 400, 130);
        AbortAutoPlace(this->m_hWnd);

        theApp.BeginWaitCursor();

        for ( pos = FileDlg.GetStartPosition();
              pos != NULL;
              /* none */ ) 
        {
          sFile = FileDlg.GetNextPathName(pos);

          strcpy(szSrc, sFile);
          strcpy(szDst, szSrc);
          strcat(szDst, AppSettings.szAsciiSuffix);
 
          {
            char szMsg[_MAX_PATH+128];

            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_CRYPTINGFILE), szSrc);
            AbortSetText(hwndAbort, szMsg);
            bAbort |= Abort(hwndAbort);
            if (bAbort)
              break; // Abbruch
          }

          if (OverflowKeyStream(FileSize(szSrc, NULL), &AppSettings.KeyFileHistory[0]))
          {
            bAbort = TRUE;
            break; // break for pos
          }

          if (EncodeASCIIFile (TRUE,  AppSettings.bConsumeKey, szPwd, szSrc, szDst, &AppSettings.KeyFileHistory[0]) )
          {
            if (bDelete)
              EraseFile(szSrc, TRUE);

          } else 
          {
            MessageBeep(0);
            
            char szMsg[_MAX_PATH+128];
            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
            
            if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
            { 
              bAbort = TRUE;
              break;
            }
          }

        } // for all selected files

        theApp.EndWaitCursor();

        AbortRemove(hwndAbort);
      
      } else  MessageBeep(0);

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

  if (bAbort) SetStatusText(CString((LPCSTR)IDS_ABORT));
  else        SetStatusText(CString((LPCSTR)IDS_READY));

  UpdateKeyStreamPopup();
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnDecodeAscii() 
{
  BOOL bAbort = FALSE;
  char szMask1[128], szMask2[128];
  CString sASCIIFiles((LPCSTR)IDS_ASCIIFILES);

  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      GetFMask(szMask1, AppSettings.szAsciiSuffix),  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      GetFMask2(szMask2, (char *)(LPCSTR)sASCIIFiles, AppSettings.szAsciiSuffix), 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_DECODEASCIIFILE);
    GetFMask(FileDlg.m_ofn.lpstrFile, AppSettings.szAsciiSuffix);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szPwd[MAX_PWD_SIZE+1];
	    CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
	    
      if (dlgKey.DoModal() == IDOK)
      {
        char szSrc[_MAX_PATH];
        char szDst[_MAX_PATH];
        CString sFile;
        POSITION pos;
        BOOL  bDelete = FALSE;

        if (AppSettings.bDeleteafterOperation) 
          bDelete = MessageBox(CString((LPCSTR)IDS_DELETEAFTERDONE), CString((LPCSTR)IDS_DELETE), MB_YESNO | MB_ICONQUESTION) == IDYES;

        HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char *)(LPCTSTR)CString((LPCSTR)IDS_DECRYPTING), "");
        AbortDlgSetSize(hwndAbort, 400, 130);
        AbortAutoPlace(this->m_hWnd);

        theApp.BeginWaitCursor();

        for ( pos = FileDlg.GetStartPosition();
              pos != NULL;
              /* none */ ) 
        {
          sFile = FileDlg.GetNextPathName(pos);

          strcpy(szSrc, sFile);
          MakeFName(szSrc, szDst, AppSettings.szDecodePrefix, AppSettings.szAsciiSuffix);

          {
            char szMsg[_MAX_PATH+128];

            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_DECRYPTINGFILE), szSrc);
            AbortSetText(hwndAbort, szMsg);
            bAbort |= Abort(hwndAbort);
            if (bAbort)
              break; // Abbruch
          }

          if (EncodeASCIIFile (FALSE,  AppSettings.bConsumeKey, szPwd, szSrc, szDst, &AppSettings.KeyFileHistory[0]) )
          {
            if (bDelete)
              EraseFile(szSrc, TRUE);

          } else 
          {
            MessageBeep(0);
            
            char szMsg[_MAX_PATH+128];
            sprintf(szMsg, (char *)(LPCTSTR)CString((LPCSTR)IDS_FILEERROR), szSrc);
            
            if ( MessageBox(szMsg, CString((LPCSTR)IDS_ERROR), MB_YESNO | MB_ICONSTOP) == IDNO)
            { 
              bAbort = TRUE;
              break;
            }
          }

        } // for all selected files

        theApp.EndWaitCursor();

        AbortRemove(hwndAbort);
      
      } else  MessageBeep(0);

    } // if FileDlg

    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

  if (bAbort) SetStatusText(CString((LPCSTR)IDS_ABORT));
  else        SetStatusText(CString((LPCSTR)IDS_READY));

  UpdateKeyStreamPopup();

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnLoadText() 
{
  CFileDialog FileDlg(TRUE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szTxtFileMask,  //lpszDefExt        The default filename extension
                      "",     //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES, 
                      szTxtFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 1024;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_LOADTXTFILE);
    strcpy(FileDlg.m_ofn.lpstrFile, szTxtFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char   szFileName[_MAX_PATH];
      char * pText;
      long   nText;

      theApp.BeginWaitCursor();

      strcpy(szFileName, FileDlg.GetPathName());
      pText = LoadText(szFileName, &nText);

      theApp.EndWaitCursor();

      if (pText != NULL)
      {
        CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
        int m = pTextCtrl->GetLimitText();

        if (nText > m)
        {
          MessageBeep(0);
          CString sErr((LPCSTR)IDS_ERROR);
          CString sMsg((LPCSTR)IDS_TEXTTOLONG);
          MessageBox(sMsg, sErr, MB_OK | MB_ICONEXCLAMATION );
          pText[m] = '\0';

          SetStatusText(CString((LPCSTR)IDS_TEXTOVERFLOW));
        
        } else SetStatusText(CString((LPCSTR)IDS_READY));

        OnClear();
        pTextCtrl->SetWindowText(pText);
//        pTextCtrl->FmtLines(FALSE);
        pTextCtrl->SetFocus();

        FREE(pText);

      } else 
      {
        MessageBeep(0);
        CString sErr((LPCSTR)IDS_ERROR);
        CString sMsg((LPCSTR)IDS_LOADERROR);
        MessageBox(sMsg, sErr, MB_OK | MB_ICONERROR );
       
        SetStatusText(CString((LPCSTR)IDS_STERROR));
      }
      
    }
    
    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnSaveText() 
{
  CEdit *pTextCtrl;
  int    nText, n;

  pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
  nText = pTextCtrl->GetWindowTextLength();

  if (nText != 0)
  {
    char *pText = (char *) MALLOC(nText + 1);

    if (pText != NULL)
    {
      // Text holen
      n = pTextCtrl->GetWindowText(pText, nText + 1);
      if (n < 0) n += 65536; // Scheiss 16-Bit-Rest

      CFileDialog FileDlg(FALSE,   //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                          szTxtFileMask,  //lpszDefExt        The default filename extension
                          "",     //lpszFileName      The initial filename that appears in the filename edit box
                          OFN_FILEMUSTEXIST | OFN_LONGNAMES, 
                          szTxtFileMask2, 
                          this);
      FileDlg.m_ofn.nMaxFile   = 1024;
      FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

      if (FileDlg.m_ofn.lpstrFile != NULL) 
      {
        CString sTitle((LPCSTR)IDS_SAVETXTFILE);
        strcpy(FileDlg.m_ofn.lpstrFile, szTxtFileMask);
        FileDlg.m_ofn.lpstrTitle = sTitle;

        if (FileDlg.DoModal() == IDOK) 
        {
          char szFileName[_MAX_PATH];

          theApp.BeginWaitCursor();

          strcpy(szFileName, FileDlg.GetPathName());

          if ( !SaveText(szFileName, nText, pText) )
          {
            MessageBeep(0);
            CString sErr((LPCSTR)IDS_ERROR);
            CString sMsg((LPCSTR)IDS_SAVEERROR);
            MessageBox(sMsg, sErr, MB_ICONERROR | MB_OK);

            SetStatusText(CString((LPCSTR)IDS_STERROR));

          } else SetStatusText(CString((LPCSTR)IDS_READY));

          theApp.EndWaitCursor();
    
        }
  
        FREE(FileDlg.m_ofn.lpstrFile);

      } else MessageBeep(0);

    }  else MessageBeep(0);

    FREE(pText);

  }  else MessageBeep(0);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnAboutBox() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();

  SetStatusText(CString((LPCSTR)IDS_READY));
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnRandomTest() 
{
  long rnd0 = 0;
  
  TestRandomGenerator(&rnd0, 0, 1 << 20);
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnKeybuilder() 
{
  CDlgKeyWizard dlgKeyWiz(IDS_APP, this, 0);
  CDlgKeyWiz1 dlgWiz1(&dlgKeyWiz);
  CDlgKeyWiz2 dlgWiz2(&dlgKeyWiz);
  CDlgKeyWiz3 dlgWiz3(&dlgKeyWiz);

  dlgKeyWiz.AddPage((CPropertyPage *)&dlgWiz1);
  dlgKeyWiz.AddPage((CPropertyPage *)&dlgWiz2);
  dlgKeyWiz.AddPage((CPropertyPage *)&dlgWiz3);
      
  dlgKeyWiz.m_psh.dwFlags  |= PSH_NOAPPLYNOW | PSH_USEICONID | PSH_WIZARD;
  dlgKeyWiz.m_psh.hInstance = (HINSTANCE)GetWindowLong(this->m_hWnd, GWL_HINSTANCE);
  dlgKeyWiz.m_psh.pszIcon   = MAKEINTRESOURCE(IDI_KEY);

  // Ergebnis irrelevant
  dlgKeyWiz.DoModal();

  SetStatusText(CString((LPCSTR)IDS_READY));
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnEinstellungen() 
{
  CDlgSettings dlgSettings(&AppSettings);
  
  if (dlgSettings.DoModal() == IDOK)
  {
    // Einstellungen speichern
    LongRndInit(AppSettings.lRndMul, AppSettings.lRndAdd);
    theApp.SaveSettings();
  }

  SetStatusText(CString((LPCSTR)IDS_READY));
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
  CWnd *pCtrl;
  enum { RAND = 10 };
  int x0 = RAND,
      y0 = RAND,
      y1 = RAND+40,
      xr = RAND+120,
      x1 = cx - xr + RAND,
      x2 = cx-xr+2*RAND;
	
  // Kontrollelemente der Fenstergre anpassen
  pCtrl = CDialog::GetDlgItem(IDC_EDITTEXT);
  if (pCtrl != NULL) pCtrl->MoveWindow(x0, y0, cx - xr, cy - 20 - 3*RAND - 20);

//  pCtrl = CDialog::GetDlgItem(IDC_FILELIST);
//  if (pCtrl != NULL) pCtrl->MoveWindow(x0, y0, cx - xr, cy - 20 - 3*RAND - 20);

  pCtrl = CDialog::GetDlgItem(IDC_BUTTONCIPHER);
  if (pCtrl != NULL) pCtrl->MoveWindow(x2, y1, 100, 25);

  pCtrl = CDialog::GetDlgItem(IDC_BUTTONDECRYPT);
  if (pCtrl != NULL) pCtrl->MoveWindow(x2, y1+25+RAND, 100, 25);

//  pCtrl = CDialog::GetDlgItem(IDC_BROWSEFILES);
//  if (pCtrl != NULL) pCtrl->MoveWindow(x2, y1+25+RAND+25+RAND, 100, 25);
  
  pCtrl = CDialog::GetDlgItem(IDC_CLOSE);
  if (pCtrl != NULL) pCtrl->MoveWindow(x2, cy-RAND-25 - 20 - 30, 100, 25);

  pCtrl = CDialog::GetDlgItem(IDC_STATIC_KEY);
  if (pCtrl != NULL) pCtrl->MoveWindow(x2+50-16, y0, 32, 32);

  pCtrl = CDialog::GetDlgItem(IDC_STATIC_KEYNAME);
  if (pCtrl != NULL) pCtrl->MoveWindow(x0, cy-RAND-25+5 - 20, 60, 20);

  pCtrl = CDialog::GetDlgItem(IDC_BROWSEKEYFILE);
  if (pCtrl != NULL) pCtrl->MoveWindow(x1-20, cy-RAND-25 - 20, 20, 22);
	
  pCtrl = CDialog::GetDlgItem(IDC_COMBOKEY);
  if (pCtrl != NULL) pCtrl->MoveWindow(x0+60, cy-RAND-25 - 20, cx-xr-60-10-20, 20);

  pCtrl = CDialog::GetDlgItem(IDC_STATUS);
  if (pCtrl != NULL) pCtrl->MoveWindow(x0, cy-RAND-15, cx-2*RAND, 20);

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnGetMinMaxInfo( MINMAXINFO FAR* lpMMI )
{
	CDialog::OnGetMinMaxInfo(lpMMI);

  // Minimale Dialogboxbreite und -hhe definieren
  lpMMI->ptMinTrackSize.x = 350;
  lpMMI->ptMinTrackSize.y = 250;
}

//-----------------------------------------------------------------------------

//void CMyOneTimePadDlg::SetMode(int nMode) 
//{
//  switch (nMode)
//  {
//    case 0: // Text-Modus:
//      CDialog::GetDlgItem(IDC_EDITTEXT)->ShowWindow(SW_SHOW);
//      CDialog::GetDlgItem(IDC_FILELIST)->ShowWindow(SW_HIDE);
//      CDialog::GetDlgItem(IDC_BROWSEFILES)->ShowWindow(SW_HIDE);
//      CDialog::GetDlgItem(IDC_EDITTEXT)->SetFocus();
//      break;
//
//    case 1: // File-Modus:
//      CDialog::GetDlgItem(IDC_EDITTEXT)->ShowWindow(SW_HIDE);
//      CDialog::GetDlgItem(IDC_FILELIST)->ShowWindow(SW_SHOW);
//      CDialog::GetDlgItem(IDC_BROWSEFILES)->ShowWindow(SW_SHOW);
//      CDialog::GetDlgItem(IDC_FILELIST)->SetFocus();
//      break;
//
//  } // switch
//}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnInitMenu( CMenu * pMenu)
{
  CEdit *pTextCtrl = (CEdit *)GetDlgItem(IDC_EDITTEXT);
  CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);
  int   nStart, nStop;
  
  pTextCtrl->GetSel(nStart, nStop);

  pMenu->EnableMenuItem(IDM_UNDO, MF_BYCOMMAND|(pTextCtrl->CanUndo() ? MF_ENABLED : MF_GRAYED));
  pMenu->EnableMenuItem(IDM_COPY, MF_BYCOMMAND|( nStart != nStop ? MF_ENABLED : MF_GRAYED));
  pMenu->EnableMenuItem(IDM_CUT,  MF_BYCOMMAND|( nStart != nStop ? MF_ENABLED : MF_GRAYED));
  
//  if (AppSettings.nViewMode == 0)
//  {
    int nText = pTextCtrl->GetWindowTextLength();

    pMenu->EnableMenuItem(IDM_VERSCHLUESSELN,  MF_BYCOMMAND|( nText != 0 ? MF_ENABLED : MF_GRAYED));
    pMenu->EnableMenuItem(IDM_ENTSCHLUESSELN,  MF_BYCOMMAND|( nText != 0 ? MF_ENABLED : MF_GRAYED));
//  } else
//  {
//    int nList = pListbox->GetCount();

//    pMenu->EnableMenuItem(IDM_VERSCHLUESSELN,  MF_BYCOMMAND|( nList != 0 ? MF_ENABLED : MF_GRAYED));
//    pMenu->EnableMenuItem(IDM_ENTSCHLUESSELN,  MF_BYCOMMAND|( nList != 0 ? MF_ENABLED : MF_GRAYED));
//  }

  //pMenu->EnableMenuItem(IDM_CLOSE, MF_BYCOMMAND|MF_GRAYED);
//  pMenu->CheckMenuItem(IDM_TEXTMODE, MF_BYCOMMAND|(AppSettings.nViewMode == 0 ? MF_CHECKED : MF_UNCHECKED));
//  pMenu->CheckMenuItem(IDM_FILEMODE, MF_BYCOMMAND|(AppSettings.nViewMode == 1 ? MF_CHECKED : MF_UNCHECKED));

}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnEntschluesseln() 
{
  OnButtonDecode();
	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnVerschluesseln() 
{
  OnButtonCipher();
	
}

//-----------------------------------------------------------------------------

//void CMyOneTimePadDlg::OnTextMode() 
//{
//  AppSettings.nViewMode = 0;
//  SetMode(AppSettings.nViewMode);
//	
//}

//-----------------------------------------------------------------------------

//void CMyOneTimePadDlg::OnFileMode() 
//{
//  AppSettings.nViewMode = 1;
//  SetMode(AppSettings.nViewMode);
//	
//}

//-----------------------------------------------------------------------------
#if 0
void CMyOneTimePadDlg::OnBrowseFiles() 
{
  CFileDialog FileDlg(TRUE,    //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask, //lpszDefExt        The default filename extension
                      "",      //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle((LPCSTR)IDS_ADDFILES);
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      CString sFile;
      POSITION pos;
      char buf[_MAX_PATH];
      CListBox *pListbox = (CListBox *)GetDlgItem(IDC_FILELIST);

      //theApp.BeginWaitCursor();
      
      for ( pos = FileDlg.GetStartPosition();
            pos != NULL;
            /* none */ ) 
      {

        sFile = FileDlg.GetNextPathName(pos);

        strcpy(buf, sFile);
        ListboxFillFiles(TRUE, pListbox, "", buf, &AppSettings, this);

      } // for all selected files

      //theApp.EndWaitCursor();
    }
    
    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);
	
}
#endif

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnButtonCipher() 
{
//  if (AppSettings.nViewMode == 0)
    OnCipherText();
//  else OnCipherFiles();
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnButtonDecode() 
{
//  if (AppSettings.nViewMode == 0)
    OnDecodeText();
//  else OnDecodeFiles();
}

//-----------------------------------------------------------------------------

//void CMyOneTimePadDlg::OnCipherFiles()
//{
//Azz
//}

//-----------------------------------------------------------------------------

//void CMyOneTimePadDlg::OnDecodeFiles()
//{
//Azz
//}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnDestroy() 
{
  RECT rc;

  GetWindowRect(&rc);
  rc.right -= rc.left;
  rc.bottom-= rc.top; 
  theApp.SaveWindowPos(rc);
	
	CDialog::OnDestroy();
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnTest() 
{
  CFileDialog FileDlg(TRUE,    //bOpenFileDialog   Set to TRUE to construct a File Open dialog box or FALSE to construct a File Save As dialog box
                      szAllFileMask, //lpszDefExt        The default filename extension
                      "",      //lpszFileName      The initial filename that appears in the filename edit box
                      OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_ALLOWMULTISELECT, 
                      szAllFileMask2, 
                      this);
  FileDlg.m_ofn.nMaxFile   = 32767;
  FileDlg.m_ofn.lpstrFile  = (LPTSTR)MALLOC(FileDlg.m_ofn.nMaxFile);

  if (FileDlg.m_ofn.lpstrFile != NULL) 
  {
    CString sTitle("Test: Datei(en) verschlsseln/entschlsseln/berprfen");
    strcpy(FileDlg.m_ofn.lpstrFile, szAllFileMask);
    FileDlg.m_ofn.lpstrTitle = sTitle;

    if (FileDlg.DoModal() == IDOK) 
    {
      char szPwd[MAX_PWD_SIZE+1];
	    CDlgEnterKey dlgKey (CString((LPCSTR)IDS_PWDTITLE), MIN_PWD_SIZE, MAX_PWD_SIZE, szPwd);
	    
      if (dlgKey.DoModal() == IDOK)
      {
        BOOL    bSuccess = TRUE;
        CString sFile;
        CString sTitle((LPCSTR)IDS_TESTTITLE);
        CString sTesting((LPCSTR)IDS_TESTING);
        CString sTestErr((LPCSTR)IDS_TESTERR);
        POSITION pos;
        char buf[_MAX_PATH];
        char szMsg[_MAX_PATH+128];

        BOOL bAbort    = FALSE;
        HWND hwndAbort = AbortInstall(this->m_hWnd, FALSE, (char *)(LPCSTR)sTitle, "");
        AbortDlgSetSize(hwndAbort, 400, 130);
        AbortAutoPlace(this->m_hWnd);
        
        //theApp.BeginWaitCursor();
      
        for ( pos = FileDlg.GetStartPosition();
              pos != NULL;
              /* none */ ) 
        {
          sFile = FileDlg.GetNextPathName(pos);

          strcpy(buf, sFile);
          sprintf(szMsg, (char *)(LPCSTR)sTesting, buf);

          AbortSetText(hwndAbort, szMsg);
          bAbort |= Abort(hwndAbort);
          if (bAbort)
            break; // Abbruch

          if ( !TestCiphering(buf, szPwd, &AppSettings.KeyFileHistory[0]) )
          {
            bSuccess = FALSE;
            sprintf(szMsg, (char *)(LPCSTR)sTestErr, buf);
            MessageBeep(0);
            MessageBox(szMsg, CString((LPCSTR)IDS_TESTRESULT), MB_ICONERROR | MB_OK);
          }

        } // for all selected files

        //theApp.EndWaitCursor();
        
        AbortRemove(hwndAbort);

        if (bSuccess && !bAbort)
          MessageBox(CString((LPCSTR)IDS_TESTOK), CString((LPCSTR)IDS_TESTRESULT), MB_ICONINFORMATION | MB_OK);
      }
    }
    
    FREE(FileDlg.m_ofn.lpstrFile);

  } else MessageBeep(0);

  UpdateKeyStreamPopup();

}

//-----------------------------------------------------------------------------

BOOL CMyOneTimePadDlg::OverflowKeyStream(long nSize, KEYSTREAMINFO *pKeyInfo)
{
  if (nSize > pKeyInfo->nSize - pKeyInfo->nIndex)
  {
    SetStatusText(CString((LPCSTR)IDS_KEYOVERFLOW));
    MessageBox(CString((LPCSTR)IDS_NOKEY), CString((LPCSTR)IDS_EXCLAMATION), MB_OK | MB_ICONSTOP);
    return TRUE;
  }
  
  return FALSE;
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::CheckRWKeyFile(KEYSTREAMINFO *pKeyInfo)
{
  if (AppSettings.bConsumeKey && !pKeyInfo->bRW)
  {
    char szMsg[_MAX_PATH+128];
    CString s((LPCSTR)IDS_KEYRDONLY);

    sprintf(szMsg, s, pKeyInfo->szKeyFile);
    MessageBeep(0);
    MessageBox(szMsg, CString((LPCSTR)IDS_EXCLAMATION), MB_OK | MB_ICONWARNING);   
  }
  
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::OnLicense() 
{
  theApp.AskLicenseAgreement();	
}

//-----------------------------------------------------------------------------

void CMyOneTimePadDlg::SetStatusText(LPCTSTR szText)
{
  pStatus->SetWindowText(szText);
}

//-----------------------------------------------------------------------------
