/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

// OneTimePadDlg.h : Header-Datei
//

#if !defined(AFX_ONETIMEPADDLG_H__1E8EB5C4_2A48_11D7_A1AF_909CBD5DBF43__INCLUDED_)
#define AFX_ONETIMEPADDLG_H__1E8EB5C4_2A48_11D7_A1AF_909CBD5DBF43__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "OneTimePadTl.h"

/////////////////////////////////////////////////////////////////////////////
// CMyOneTimePadDlg Dialogfeld

class CMyOneTimePadDlg : public CDialog
{
// Konstruktion
public:
	CMyOneTimePadDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CMyOneTimePadDlg)
	enum { IDD = IDD_MYONETIMEPAD_DIALOG };
		// HINWEIS: der Klassenassistent fgt an dieser Stelle Datenelemente (Members) ein
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CMyOneTimePadDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
public:
  void UpdateKeyStreamPopup(void);
  BOOL OverflowKeyStream(long nSize, KEYSTREAMINFO *pKeyInfo);
  void SetMode(int nMode);
  void OnCipherText(); 
  void OnDecodeText();

//  void OnCipherFiles();
//  void OnDecodeFiles();
  
  void SetStatusText(LPCTSTR szText);
  void CheckRWKeyFile(KEYSTREAMINFO *pKeyInfo);

protected:
	HICON m_hIcon;
  CStatic *pStatus; // Status-Control-Element

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CMyOneTimePadDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnKeybuilder();
	afx_msg void OnBrowseKeyfile();
	afx_msg void OnButtonCipher();
	afx_msg void OnButtonDecode();
	afx_msg void OnClear();
	afx_msg void OnPaste();
	afx_msg void OnCut();
	afx_msg void OnCopy();
	afx_msg void OnMarkAll();
	afx_msg void OnClose();
	afx_msg void OnSelchangeCombokey();
	afx_msg void OnConvtoAscii();
	afx_msg void OnConvtoBin();
	afx_msg void OnCryptBin();
	afx_msg void OnCryptAscii();
	afx_msg void OnDecodeBin();
	afx_msg void OnDecodeAscii();
	afx_msg void OnLoadText();
	afx_msg void OnSaveText();
	afx_msg void OnUndo();
	afx_msg void OnAboutBox();
	afx_msg void OnRandomTest();
	afx_msg void OnEinstellungen();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
  afx_msg void OnInitMenu(CMenu *pMenu);
	afx_msg void OnEntschluesseln();
	afx_msg void OnVerschluesseln();
	//afx_msg void OnTextMode();
	//afx_msg void OnFileMode();
	//afx_msg void OnBrowseFiles();
	afx_msg void OnDestroy();
	afx_msg void OnTest();
	afx_msg void OnLicense();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_ONETIMEPADDLG_H__1E8EB5C4_2A48_11D7_A1AF_909CBD5DBF43__INCLUDED_)
