/*
//-----------------------------------------------------------------------------
OSS - OneTimePad V1.0 (C) 2003 by A. Ogut. All rights reserved. 

License to copy and use this software is granted provided that it 
is identified as the "OSS - OneTimePad" in all material mentioning 
or referencing this software or this function. 

License is also granted to make and use derivative works provided 
that such works are identified as "derived from the OSS - OneTimePad" 
in all material mentioning or referencing the derived work. 

OSS - Ogut Software Systems makes no representations concerning either 
the merchantability of this software or the suitability of this 
software for any particular purpose. It is provided "as is" 
without express or implied warranty of any kind. 

These notices must be retained in any copies of any part of this 
documentation and/or software. 
//-----------------------------------------------------------------------------
*/

/* preproc.h */

#ifndef __INC_PREPROC__
#define __INC_PREPROC__

#ifdef __cplusplus
extern "C" { // Assume C declarations for C++
#endif       // __cplusplus 

//-----------------------------------------------------------------------------------

#define LIBAPI              WINAPI


//--- DEBUG ---
#ifdef _DEBUG
#define DEBUGOUTIF(condition, s)       if (condition) OutputDebugString(s)
#define DEBUGOUT(s)                    OutputDebugString(s)
#define DEBUGOUTERR(condition, s, ret) if (condition) {OutputDebugString(s); return (ret);}
#else
#define DEBUGOUTIF(condition, s)
#define DEBUGOUT(s)
#define DEBUGOUTERR(condition, s, ret) if (condition) return (ret)
#endif

//-----------------------------------------------------------------------------------

#include <crtdbg.h> 
#define ASSERT_PTR(ptr)    _ASSERTE(ptr)
#define ASSERT_TRUE(cond)  _ASSERTE(!(cond))
#define ASSERT_FALSE(cond) _ASSERTE(cond)

//-----------------------------------------------------------------------------------

// Erlaubt Debug-Informationen zum Speichermanager
//#define MALLOC_DEBUG

// Wenn definiert -> bei jedem malloc() und free() Informationen ausgeben
// Wenn nicht definiert -> nur bei neuem max ausgeben
//#define MALLOC_FULLDEBUGINFO

//-----------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------


#ifdef __cplusplus
}       // End of extern "C" {
#endif  // __cplusplus


//-----------------------------------------------------------------------------------

#endif // __INC_PREPROC__

